//
//  camswipeguiAppDelegate.m
//  camswipegui
//
//  Created by Daniel Pollack on 6/16/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "camswipeguiAppDelegate.h"

@implementation camswipeguiAppDelegate

@synthesize window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// Insert code here to initialize your application 
}

- (IBAction)startRecording:(id)sender
{
	// Create a new Capture Session
	mCaptureSession = [[QTCaptureSession alloc] init]; 
	
	//Connect inputs and outputs to the session
	BOOL success = NO;
	NSError *error;
	
	// Find a video device
	QTCaptureDevice *device = [QTCaptureDevice defaultInputDeviceWithMediaType:QTMediaTypeVideo];
	if(device) {
		success = [device open:&error];
		if(!success) {
			// Handle Error!
		}
		// Add the video device to the session as device input
		mCaptureDeviceInput = [[QTCaptureDeviceInput alloc] initWithDevice:device];
		success = [mCaptureSession addInput:mCaptureDeviceInput error:&error];
		
		//mCaptureDecompressedVideoOutput = [[QTCaptureDecompressedVideoOutput alloc] init];
		mCaptureDecompressedVideoOutput = [[QTCaptureVideoPreviewOutput alloc] init];
		
		[mCaptureDecompressedVideoOutput setDelegate:self];
		success = [mCaptureSession addOutput:mCaptureDecompressedVideoOutput error:&error];
		
		if(!success) {
			// Handle error
		}
		
		// Associate the capture view in the UI with the session
		[mCaptureView setCaptureSession:mCaptureSession];
		
		// Start the capture session runing
		[mCaptureSession startRunning];
		
	} // End if device
}
/*
readImage(NSImage *image, NSInteger height, NSInteger width, CGFloat **r1, CGFloat **b1, CGFloat **g1) {
	[image lockFocus];
	CGFloat a1;
	for(int x = 0; x < width; ++x) {
		for(int y = 0; y < height; ++y) {
			NSColor *c1 = NSReadPixel(NSMakePoint(x,y));
			[c1 getRed:&(r1[y][x]) green:&(g1[y][x]) blue:&b1([y][x]) alpha:&a1];
		}
	}
	[image unlockFocus];
}
*/

- (void)captureOutput:(QTCaptureOutput *)captureOutput didOutputVideoFrame:(CVImageBufferRef)videoFrame withSampleBuffer:(QTSampleBuffer *)sampleBuffer fromConnection:(QTCaptureConnection *)connection{
	//process frame

	static NSBitmapImageRep *prev = nil;

	if (videoFrame) {
        //NSCIImageRep *imageRep = [NSCIImageRep imageRepWithCIImage:[CIImage imageWithCVImageBuffer:videoFrame]];
		
        NSBitmapImageRep *image = [[NSBitmapImageRep alloc] initWithCIImage:[CIImage imageWithCVImageBuffer:videoFrame]];
		[image autorelease];
		
		//NSLog(@"Samples: %d", [image samplesPerPixel]);	// 4 means RGBA
		// 3 RGB
		// 2 grey with alpha
		// 1 grey
		
		if(prev) {
			//Only support RGBA for now		
			RGBAPixel *oldPixels = (RGBAPixel *)[prev bitmapData];  // -bitmapData returns a void*, not an NSData object ;-)
			RGBAPixel *newPixels = (RGBAPixel *)[image bitmapData];
			
			int 
			row, 
			column,
			widthInPixels = [image pixelsWide], 
			heightInPixels = [image pixelsHigh];
			
			int xChange = 0;
			int weight = 0;
			int yChange = 0;
			
			for (row = 0; row < heightInPixels; row++) {
				for (column = 0; column < widthInPixels; column++) {
					RGBAPixel *oldPixel = (RGBAPixel *) &(oldPixels[((widthInPixels * row) + column)]);
					RGBAPixel *newPixel = (RGBAPixel *) &(newPixels[((widthInPixels * row) + column)]);
					int delta = abs(0+oldPixel->redByte+oldPixel->blueByte+oldPixel->greenByte-(0+newPixel->redByte+newPixel->blueByte+newPixel->greenByte));
					if(delta > 100){
						//NSLog(@"Delta: %d", delta);
						weight++;
						xChange += column;
						yChange += row;
					}
					//thisPixel->redByte = (255 - thisPixel->redByte);
					//thisPixel->greenByte = (255 - thisPixel->greenByte);
					//thisPixel->blueByte = (255 - thisPixel->blueByte);
				}
			}
			
			if (weight > 0) {
				//NSLog(@"Center of change = (%f, %f)", xChange*1.0/weight, yChange*1.0/weight);
				int x = (int)(xChange*1.0/weight);
				//int y = (int)(yChange*1.0/weight);
				
				static int xp = 0;
				static int lastdir = 0;
				static int consec = 0;
				
				if(xp != 0)
				{
					int dist = x-xp;
					int dir = -1;
					if(dist > 0)
						dir = 1;
					//NSLog(@"distance: %d X: %d", dist, x);
					if(lastdir == dir)
					{
						if(dist*dir >= 15)
						{
							++consec;
							//NSLog(@"consec %d", consec);
							if(consec == 3)
								if(dir == 1) {
									NSLog(@"Flip dir 1");
									/*
									 keystroke (ASCII character 28) -- Left
									 keystroke (ASCII character 29) -- Right
									 keystroke (ASCII character 30) -- Up
									 keystroke (ASCII character 31) -- Down
									 */
									NSAppleScript *run = [[NSAppleScript alloc] initWithSource:@"tell application \"System Events\"\nkeystroke (ASCII character 28) using {control down}\nend tell"];
									[run autorelease];
									[run executeAndReturnError:nil];
								} else {
									NSLog(@"Flip dir 2");
									NSAppleScript *run = [[NSAppleScript alloc] initWithSource:@"tell application \"System Events\"\nkeystroke (ASCII character 29) using {control down}\nend tell"];
									[run autorelease];
									[run executeAndReturnError:nil];

								}
						}
						else
							consec = 0;
						
					}
					else
						consec = 0;
					
					lastdir = dir;
				}
				xp = x;
			}

		}
		[prev release];
		prev = image;
		[prev retain]; 
    }
	//NSLog(@"captureOutput!");
}

@end
